/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.lib.debug;

import java.util.ArrayList;
import java.util.List;

import javax.annotation.Nullable;

import net.minecraft.client.Minecraft;
import net.minecraft.client.multiplayer.WorldClient;
import net.minecraft.entity.Entity;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.RayTraceResult;

import buildcraft.api.tiles.IDebuggable;

public class ClientDebuggables {
    public static final List<String> SERVER_LEFT = new ArrayList<>();
    public static final List<String> SERVER_RIGHT = new ArrayList<>();

    @Nullable
    public static IDebuggable getDebuggableObject(RayTraceResult mouseOver) {
        Minecraft mc = Minecraft.func_71410_x();
        if (mc.field_71474_y.field_178879_v || mc.field_71439_g.func_175140_cp() || !mc.field_71439_g.field_71075_bZ.field_75098_d
            || !mc.field_71474_y.field_74330_P) {
            return null;
        }
        if (mouseOver == null) {
            return null;
        }
        RayTraceResult.Type type = mouseOver.field_72313_a;
        WorldClient world = mc.field_71441_e;
        if (world == null) {
            return null;
        }
        if (type == RayTraceResult.Type.BLOCK) {
            BlockPos pos = mouseOver.func_178782_a();
            TileEntity tile = world.func_175625_s(pos);
            if (tile instanceof IDebuggable) {
                return (IDebuggable) tile;
            }
        } else if (type == RayTraceResult.Type.ENTITY) {
            Entity entity = mouseOver.field_72308_g;
            if (entity instanceof IDebuggable) {
                return (IDebuggable) entity;
            }
        }
        return null;
    }
}
